/* ../src/sstdiag.f -- translated by f2c (version 19950110).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;

/* ccccccccc FORTRAN subroutine sstdg cccccccccc */
/* For computing the diagonal entries of the "binned" */
/* version of SS^T, where S is a smoother matrix for */
/* local polynomial fitting. */
/* Last changed: 10/02/95 */
/* Subroutine */ int sstdg_(xcounts, delta, hdisc, lvec, indic, midpts, m, iq,
	 fkap, ipp, ippp, ss, uu, smat, umat, work, det, ipvt, sstd)
doublereal *xcounts, *delta, *hdisc;
integer *lvec, *indic, *midpts, *m, *iq;
doublereal *fkap;
integer *ipp, *ippp;
doublereal *ss, *uu, *smat, *umat, *work, *det;
integer *ipvt;
doublereal *sstd;
{
    /* System generated locals */
    integer ss_dim1, ss_offset, uu_dim1, uu_offset, smat_dim1, smat_offset, 
	    umat_dim1, umat_offset, i__1, i__2, i__3, i__4, i__5, i__6, i__7;
    doublereal d__1;

    /* Builtin functions */
    double exp();

    /* Local variables */
    static integer info;
    extern /* Subroutine */ int dgefa_();
    static integer i, j, k;
    extern /* Subroutine */ int dgedi_();
    static integer indss, ii;
    static doublereal fac;
    static integer mid;

/* Obtain kernel weights */
    /* Parameter adjustments */
    --xcounts;
    --hdisc;
    --lvec;
    --indic;
    --midpts;
    --fkap;
    umat_dim1 = *ipp;
    umat_offset = umat_dim1 + 1;
    umat -= umat_offset;
    smat_dim1 = *ipp;
    smat_offset = smat_dim1 + 1;
    smat -= smat_offset;
    uu_dim1 = *m;
    uu_offset = uu_dim1 + 1;
    uu -= uu_offset;
    ss_dim1 = *m;
    ss_offset = ss_dim1 + 1;
    ss -= ss_offset;
    --work;
    --det;
    --ipvt;
    --sstd;

    /* Function Body */
    mid = lvec[1] + 1;
    i__1 = *iq - 1;
    for (i = 1; i <= i__1; ++i) {
	midpts[i] = mid;
	fkap[mid] = (float)1.;
	i__2 = lvec[i];
	for (j = 1; j <= i__2; ++j) {
/* Computing 2nd power */
	    d__1 = *delta * j / hdisc[i];
	    fkap[mid + j] = exp(-(d__1 * d__1) / 2);
	    fkap[mid - j] = fkap[mid + j];
/* L20: */
	}
	mid = mid + lvec[i] + lvec[i + 1] + 1;
/* L10: */
    }
    midpts[*iq] = mid;
    fkap[mid] = (float)1.;
    i__1 = lvec[*iq];
    for (j = 1; j <= i__1; ++j) {
/* Computing 2nd power */
	d__1 = *delta * j / hdisc[*iq];
	fkap[mid + j] = exp(-(d__1 * d__1) / 2);
	fkap[mid - j] = fkap[mid + j];
/* L30: */
    }
/* Combine kernel weights and grid counts */
    i__1 = *m;
    for (k = 1; k <= i__1; ++k) {
	if (xcounts[k] != 0.) {
	    i__2 = *iq;
	    for (i = 1; i <= i__2; ++i) {
/* Computing MAX */
		i__3 = 1, i__4 = k - lvec[i];
/* Computing MIN */
		i__6 = *m, i__7 = k + lvec[i];
		i__5 = min(i__6,i__7);
		for (j = max(i__3,i__4); j <= i__5; ++j) {
		    if (indic[j] == i) {
			fac = (float)1.;
			ss[j + ss_dim1] += xcounts[k] * fkap[k - j + midpts[i]
				];
/* Computing 2nd power */
			d__1 = fkap[k - j + midpts[i]];
			uu[j + uu_dim1] += xcounts[k] * (d__1 * d__1);
			i__3 = *ippp;
			for (ii = 2; ii <= i__3; ++ii) {
			    fac = fac * *delta * (k - j);
			    ss[j + ii * ss_dim1] += xcounts[k] * fkap[k - j + 
				    midpts[i]] * fac;
/* Computing 2nd power */
			    d__1 = fkap[k - j + midpts[i]];
			    uu[j + ii * uu_dim1] += xcounts[k] * (d__1 * d__1)
				     * fac;
/* L70: */
			}
		    }
/* L60: */
		}
/* L50: */
	    }
	}
/* L40: */
    }
    i__1 = *m;
    for (k = 1; k <= i__1; ++k) {
	sstd[k] = 0.;
	i__2 = *ipp;
	for (i = 1; i <= i__2; ++i) {
	    i__5 = *ipp;
	    for (j = 1; j <= i__5; ++j) {
		indss = i + j - 1;
		smat[i + j * smat_dim1] = ss[k + indss * ss_dim1];
		umat[i + j * umat_dim1] = uu[k + indss * uu_dim1];
/* L100: */
	    }
/* L90: */
	}
	dgefa_(&smat[smat_offset], ipp, ipp, &ipvt[1], &info);
	dgedi_(&smat[smat_offset], ipp, ipp, &ipvt[1], &det[1], &work[1], &
		c__1);
	i__2 = *ipp;
	for (i = 1; i <= i__2; ++i) {
	    i__5 = *ipp;
	    for (j = 1; j <= i__5; ++j) {
		sstd[k] += smat[i * smat_dim1 + 1] * umat[i + j * umat_dim1] *
			 smat[j + smat_dim1];
/* L120: */
	    }
/* L110: */
	}
/* L80: */
    }
    return 0;
} /* sstdg_ */

